
////////////////////////////////////////////////////////////
// Headers
////////////////////////////////////////////////////////////
#include <stdio.h>

#include <SFML/Graphics.hpp>
#define DISK_MAX 1024

struct unitdisk {
	unitdisk() {
		selected = false;
	}
	int x;
	int y;
	bool selected;
};

struct unitdisk disks[DISK_MAX];
int disk_count = 0;

int packable(int*idx, int count) {
	return 1;
}

int recurse_pack(int step, unsigned long long& encoding, int count, int* idx) {

	int i;
	int j;
	if ( step > count ) {
		int mcount = 0;
		for ( i = 0; i < count; i++ ) {
			if ( (encoding >> i )%2 == 0 ) continue;
			mcount++;

			for ( j = 0; j < count; j++ ) {
				if ( i == j ) continue;
				if ( (encoding >> j )%2 == 0 ) continue;

				int x1 = disks[idx[i]].x;
				int y1 = disks[idx[i]].y;
				int x2 = disks[idx[j]].x;
				int y2 = disks[idx[j]].y;

				if ( ((x1-x2)*(x1-x2)) + ((y1-y2)*(y1-y2)) <= 900 ) {
					return 0;
				}

			}
		}

		return mcount;
	}
	
	unsigned long long zencoding = encoding;
	int zsize = recurse_pack(step+1, zencoding, count, idx);
	unsigned long long oencoding = encoding;
	oencoding += 1<<step;
	int osize = recurse_pack(step+1, oencoding, count, idx);


	if (zsize > osize ) {
		encoding = zencoding;
		return zsize;
	}
	else {
		encoding = oencoding;
		return osize;
	}
}

int* pack(int* idx, int& count) {
	unsigned long long  encoding = 0;
	int total = recurse_pack(0, encoding, count, idx);
	printf( "++ %d/%d\n", total, count);
	int i;
	int * retidx = (int*)malloc(sizeof(int)* count);
	int rcount = 0;
	for ( i = 0; i < count; i++ ) {
		if ( (encoding>>i)%2 == 1) retidx[rcount++] = idx[i];
	}
	count = rcount;
	return retidx;
}

////////////////////////////////////////////////////////////
/// Entry point of application
///
/// \return Application exit code
///
////////////////////////////////////////////////////////////
int main()
{
    // Create the main rendering window
    sf::RenderWindow App(sf::VideoMode(640, 480, 8), "Packing");
		App.SetFramerateLimit(30);

		sf::Font fontTerm;
		if (!fontTerm.LoadFromFile("Terminus.ttf"))
			return EXIT_FAILURE;
    // Load the sprite image from a file

		sf::String textClick("left-click to place disk.\nright-click to continue", fontTerm, 20);
		textClick.SetColor(sf::Color(255,255,0));
		textClick.Move(10,10);
		bool rightclicked = false;
		bool leftdown = false;
    sf::Event Event;
		while (App.IsOpened() && !rightclicked) {
			while ( App.GetEvent(Event) ) {
				if ( App.GetInput().IsMouseButtonDown(sf::Mouse::Left) )
					leftdown = true;
				else if ( leftdown ) {
					leftdown = false;
					
					if ( disk_count < DISK_MAX ) {
						disks[disk_count].x = App.GetInput().GetMouseX();
						disks[disk_count].y = App.GetInput().GetMouseY();
					//	printf( "%d %d %d\n", disks[disk_count].x, disks[disk_count].y, App.GetInput().GetMouseX() );
						disk_count++;
					}
				}
				
				if ( App.GetInput().IsMouseButtonDown(sf::Mouse::Right) ) {
					rightclicked = true;
				}

				if (Event.Type == sf::Event::Closed) {
					App.Close();
				}
			}


			App.Clear(sf::Color(0,0,0));
    	App.Draw(textClick);
			int i;
			for ( i = 0; i < disk_count; i++ ) {
				sf::Shape disktemp = sf::Shape::Circle(disks[i].x, disks[i].y, 15, sf::Color(0,0,0,0), true,
					sf::Color(0,255,0));
				App.Draw(disktemp);
			}

			App.Display();
		}
		printf( "Finished Input\n" );
		
		sf::String textGrid("move mouse to adjust grid size,\nleft-click to continue", fontTerm, 20);
		textGrid.SetColor(sf::Color(255,255,0));
		textGrid.Move(10,10);

		bool leftclicked = false;
		leftdown = false;
		int mouseX = 0;
		int mouseY = 0;
		int gridW = 0;
		while (App.IsOpened() && !leftclicked) {
			while ( App.GetEvent(Event) ) {
				if ( Event.Type == sf::Event::MouseMoved ) {
					mouseX = Event.MouseMove.X;
					mouseY = Event.MouseMove.Y;
					gridW = mouseX;
					if ( gridW < 20 ) gridW = 20;
					//if (mouseY > gridW ) gridW = mouseY;
				}
				if (Event.Type == sf::Event::Closed) {
					App.Close();
				}

				if ( App.GetInput().IsMouseButtonDown(sf::Mouse::Left) )
					leftdown = true;
				else if ( leftdown ) {
					leftdown = false;
					leftclicked = true;
				}
			}
			
			
			App.Clear(sf::Color(0,0,0));
    	App.Draw(textGrid);
			int i;
			for ( i = 0; i < disk_count; i++ ) {
				sf::Shape disktemp = sf::Shape::Circle(disks[i].x, disks[i].y, 15, 
					sf::Color(0,0,0,0), true, sf::Color(0,255,0));
				App.Draw(disktemp);
			}


			i = 0;
			while ( i * gridW < 480 & i < 100 ) {
				sf::Shape hline = sf::Shape::Line(0, i*gridW, 640, i*gridW, 1, sf::Color(255,255,255));
				App.Draw(hline);
				i++;
			}
			i = 0;
			while ( i * gridW < 640 && i < 100 ) {
				sf::Shape vline = sf::Shape::Line(gridW*i, 0, gridW*i, 480, 1, sf::Color(255,255,255));
				App.Draw(vline);
				i++;
			}

			App.Display();
		}
		
		sf::String textShift("randomly shifted grid\nleft-click to continue", fontTerm, 20);
		textShift.SetColor(sf::Color(255,255,0));
		textShift.Move(10,10);

		srand(time(NULL));
		int shamtX = rand()%(gridW-5) + 5;
		int shamtY = rand()%(gridW-5) + 5;
		leftdown = false;
		leftclicked = false;
		while (App.IsOpened() && !leftclicked) {
			while ( App.GetEvent(Event) ) {
				if (Event.Type == sf::Event::Closed) {
					App.Close();
				}

				if ( App.GetInput().IsMouseButtonDown(sf::Mouse::Left) )
					leftdown = true;
				else if ( leftdown ) {
					leftdown = false;
					leftclicked = true;
				}
			}
			
			
			App.Clear(sf::Color(0,0,0));
    	App.Draw(textShift);
			int i;
			for ( i = 0; i < disk_count; i++ ) {
				sf::Shape disktemp = sf::Shape::Circle(disks[i].x, disks[i].y, 15, 
					sf::Color(0,0,0,0), true, sf::Color(0,255,0));
				App.Draw(disktemp);
			}


			i = 0;
			while ( i * gridW < 480 & i < 100 ) {
				sf::Shape hline = sf::Shape::Line(0, i*gridW+shamtY, 640, i*gridW+shamtY, 1, sf::Color(255,255,255));
				App.Draw(hline);
				i++;
			}
			i = 0;
			while ( i * gridW < 640 && i < 100 ) {
				sf::Shape vline = sf::Shape::Line(gridW*i+shamtX, 0, gridW*i+shamtX, 480, 1, sf::Color(255,255,255));
				App.Draw(vline);
				i++;
			}

			App.Display();
		}

		sf::String textSolve("solving...", fontTerm, 20);
		textSolve.SetColor(sf::Color(255,255,0));
		textSolve.Move(10,10);
		sf::Clock Clock;
		float last = Clock.GetElapsedTime();
		int gx = -1;
		int gy = -1;
		int i;
		int totalcount = 0;
		char strbuf[256];
		while (App.IsOpened() ) {
			while ( App.GetEvent(Event) ) {
				if (Event.Type == sf::Event::Closed) {
					App.Close();
				}
			}

			if ( Clock.GetElapsedTime() - last > 1 ) {
				int startX = shamtX + gx*gridW;
				int startY = shamtY + gy*gridW;
				
				int curdiskidx[DISK_MAX];
				int curdisk_count = 0;

				for ( i = 0; i < disk_count; i++ ) {
					int x = disks[i].x;
					int y = disks[i].y;

					if ( x >= startX + 15 && x <= startX + gridW-15 &&
						y >= startY+15 && y <= startY + gridW-15 ) {
							curdiskidx[curdisk_count++] = i;
						}
				}



				if ( shamtY + gridW * gy > 480 ) {
					sprintf(strbuf, "Done Solving!\n Result: %d out of %d", totalcount, disk_count);
					textSolve.SetText(strbuf);
				} else {
					int* packidx = pack(curdiskidx, curdisk_count);
					for ( i = 0; i < curdisk_count; i++ ) {
						disks[packidx[i]].selected = true;
						totalcount ++;
					}
					//free(packidx);

					gx++;
					if ( shamtX + gridW * gx > 640 ) {
						gx = -1;
						gy++;
					}
					printf( "%d %d\n", gx, gy );
					sprintf(strbuf, "Solving... %d packed", totalcount);
					textSolve.SetText(strbuf);
				}
				Clock.Reset();
			}


			App.Clear(sf::Color(0,0,0));
			for ( i = 0; i < disk_count; i++ ) {
				if ( disks[i].selected ) {
					sf::Shape disktemp = sf::Shape::Circle(disks[i].x, disks[i].y, 15, 
						sf::Color(0,0,0,0), true, sf::Color(255,0,0));
					App.Draw(disktemp);
				} else {
					sf::Shape disktemp = sf::Shape::Circle(disks[i].x, disks[i].y, 15, 
						sf::Color(0,0,0,0), true, sf::Color(0,255,0));
					App.Draw(disktemp);
				}
			}


			i = 0;
			while ( i * gridW < 480 & i < 100 ) {
				sf::Shape hline = sf::Shape::Line(0, i*gridW+shamtY, 640, i*gridW+shamtY, 1, sf::Color(255,255,255));
				App.Draw(hline);
				i++;
			}
			i = 0;
			while ( i * gridW < 640 && i < 100 ) {
				sf::Shape vline = sf::Shape::Line(gridW*i+shamtX, 0, gridW*i+shamtX, 480, 1, sf::Color(255,255,255));
				App.Draw(vline);
				i++;
			}
			sf::Shape crect = sf::Shape::Rectangle(
				gx*gridW+shamtX, gy*gridW+shamtY, 
				(gx+1)*gridW+shamtX, (gy+1)*gridW+shamtY, 
				sf::Color(0,0,0,0), true, sf::Color(255,0,0));
			App.Draw(crect);
    	App.Draw(textSolve);

			App.Display();

		}

    return EXIT_SUCCESS;
}
